// COPYRIGHT 2011 AffiliateFox.net

if (!com) var com = {};
if (!com.affiliatefox) com.affiliatefox = {};


var affiliatefoxPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
com.affiliatefox = {
	ioService: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),

	get observerService() {
		return Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	},

	register: function () {
		this.observerService.addObserver(this, "http-on-modify-request", false);
	},

	unregister: function () {
		this.observerService.removeObserver(this, "http-on-modify-request");
	},
	// preferences declarations
	co: "",	de: "", fr: "", uk: "", jp: "", ca: "", it: "", cn: "", tagged_de: "", tagged_ca: "",
	tagged_uk: "", tagged_com: "", tagged_jp: "",	tagged_fr: "",	tagged_it: "", tagged_cn: "",
	tagged_jjp: "", tagged_juk: "", tagged_jcom: "", tagged_jde: "", session_de: "", session_ca: "", session_uk: "",
	session_com: "", session_jp: "", session_fr: "", session_it: "", session_cn: "", session_jjp: "",
	session_juk: "", session_jcom: "", session_jde: "",

	consoleService: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
	init: function (event) {
		new this.PrefListener("extensions.affiliatefox.", function (branch, name) {

			switch (name) {

			case "xco":
				this.co = affiliatefoxPref.getCharPref("extensions.affiliatefox.xco");
				break;
			case "xde":
				this.de = affiliatefoxPref.getCharPref("extensions.affiliatefox.xde");
				break;
			case "xfr":
				this.fr = affiliatefoxPref.getCharPref("extensions.affiliatefox.xfr");
				break;
			case "xuk":
				this.uk = affiliatefoxPref.getCharPref("extensions.affiliatefox.xuk");
				break;
			case "xjp":
				this.jp = affiliatefoxPref.getCharPref("extensions.affiliatefox.xjp");
				break;
			case "xca":
				this.ca = affiliatefoxPref.getCharPref("extensions.affiliatefox.xca");
				break;
			case "xit":
				this.it = affiliatefoxPref.getCharPref("extensions.affiliatefox.xit");
				break;
			case "xcn":
				this.cn = affiliatefoxPref.getCharPref("extensions.affiliatefox.xcn");
				break;
			case "xtagged_de":
				this.tagged_de = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_de");
				break;
			case "xtagged_ca":
				this.tagged_ca = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_ca");
				break;
			case "xtagged_uk":
				this.tagged_uk = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_uk");
				break;
			case "xtagged_com":
				this.tagged_com = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_com");
				break;
			case "xtagged_jp":
				this.tagged_jp = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_jp");
				break;
			case "xtagged_fr":
				this.tagged_fr = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_fr");
				break;
			case "xtagged_it":
				this.tagged_it = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_it");
				break;
			case "xtagged_cn":
				this.tagged_cn = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_cn");
				break;
			case "xtagged_jjp":
				this.tagged_jjp = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_jjp");
				break;
			case "xtagged_juk":
				this.tagged_juk = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_juk");
				break;
			case "xtagged_jcom":
				this.tagged_jcom = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_jcom");
				break;
			case "xtagged_jde":
				this.tagged_jde = affiliatefoxPref.getBoolPref("extensions.affiliatefox.xtagged_jde");
				break;
			case "xsession_de":
				this.session_de = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_de");
				break;
			case "xsession_jcom":
				this.session_jcom = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_jcom");
				break;
			case "xsession_ca":
				this.session_ca = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_ca");
				break;
			case "xsession_juk":
				this.session_juk = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_juk");
				break;
			case "xsession_uk":
				this.session_uk = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_uk");
				break;
			case "xsession_jp":
				this.session_jp = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_jp");
				break;
			case "xsession_com":
				this.session_com = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_com");
				break;
			case "xsession_jjp":
				this.session_jjp = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_jjp");
				break;
			case "xsession_jde":
				this.session_jde = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_jde");
				break;
			case "xsession_it":
				this.session_it = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_it");
				break;
			case "xsession_cn":
				this.session_cn = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_cn");
				break;
			case "xsession_fr":
				this.session_fr = affiliatefoxPref.getIntPref("extensions.affiliatefox.xsession_fr");
			}
			affiliatefoxPref.savePrefFile(null);
		}).register();

		if (event.originalTarget instanceof HTMLDocument) {
			if (event.originalTarget.nodeName == "#document") {
				var win = event.originalTarget.defaultView;
				if (!win.frameElement) {
					try {
						if (/tag=/.test(event.originalTarget.location.href)) {
							if (event.originalTarget.location.href.match(/tag=(.{2,9}(\-21|\-20|\-22|\-23))/)) {
								var minutes = Math.floor(new Date().getTime() / 60000);
								switch (RegExp.$1) {
								case "af--21":
									if (!tagged_de) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_de", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_de", minutes);
									}
									break;
								case "exampleid-20":
									if (!tagged_com) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_com", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_com", minutes);
									}
									break;
								case "e--20":
									if (!tagged_jcom) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jcom", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_jcom", minutes);
									}
									break;
								case ".e-22":
									if (!tagged_jjp) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jjp", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_jjp", minutes);
									}
									break;
								case "e--21":
									if (!tagged_juk) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_juk", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_juk", minutes);
									}
									break;
								case "-af-21":
									if (!tagged_uk) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_uk", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_uk", minutes);
									}
									break;
								case "af--22":
									if (!tagged_jp) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jp", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_jp", minutes);
									}
									break;
								case "af--20":
									if (!tagged_ca) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_ca", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_ca", minutes);
									}
									break;
								case "afj-21":
									if (!tagged_jde) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jde", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_jde", minutes);
									}
									break;
								case "a--23":
									if (!tagged_cn) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_cn", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_cn", minutes);
									}
									break;
								case "_af-21":
									if (!tagged_it) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_it", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_it", minutes);
									}
									break;
								case "-af--21":
									if (!tagged_fr) {
										affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_fr", true);
										affiliatefoxPref.setIntPref("extensions.affiliatefox.xsession_fr", minutes);
									}
								}
							}
						}
					} catch (e) {}
					this.onPageLoad(event.originalTarget);
				}
			}
		}
	},

	getpref: function (pref) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

		var prefResult;
		try {
			prefResult = prefs.getCharPref(pref);
		} catch (e) {
			prefs.setCharPref(pref, prefDefaultVal);
			prefResult = prefDefaultVal;
		}
		return prefResult;
	},

	onPageLoad: function (doc) {

		var self = this;
		var links = doc.getElementsByTagName("a");
		var links2 = doc.getElementsByTagName("area");
		var date = new Date();
		var sl = 30;
		var minutes = Math.floor(date.getTime() / 60000);
	
		if ((minutes) - session_de >= sl && tagged_de == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_de", false);
		};
		if ((minutes) - session_uk >= sl && tagged_uk == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_uk", false);
		};
		if ((minutes) - session_com >= sl && tagged_com == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_com", false);
		};
		if ((minutes) - session_juk >= sl && tagged_juk == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_juk", false);
		};
		if ((minutes) - session_jcom >= sl && tagged_jcom == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jcom", false);
		};
		if ((minutes) - session_fr >= sl && tagged_fr == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_fr", false);
		};
		if ((minutes) - session_ca >= sl && tagged_ca == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_ca", false);
		};
		if ((minutes) - session_jjp >= sl && tagged_jjp == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jjp", false);
		};
		if ((minutes) - session_jp >= sl && tagged_jp == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jp", false);
		};
		if ((minutes) - session_jde >= sl && tagged_jde == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_jde", false);
		};
		if ((minutes) - session_cn >= sl && tagged_cn == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_cn", false);
		};
		if ((minutes) - session_it >= sl && tagged_it == true) {
			affiliatefoxPref.setBoolPref("extensions.affiliatefox.xtagged_it", false);
		};

		try {
			doc.body.addEventListener("DOMNodeInserted", function (event) {
				var msg_event = Array();
				var msg_links_event = Array();
				try {
					var links_event = event.target.getElementsByTagName("a");
					com.affiliatefox.replace_url(links_event, null);
				} catch (error) {}
			}, false);
		} catch (e) {}
		com.affiliatefox.replace_url(links, links2);


	},
	observe: function (subject, topic, data) {
		if (topic == "http-on-modify-request") { 
			var hc = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
			if (/tag=((af--21)|(exampleid-20)|(-af-21)|(af--22)|(af--20)|(-af--21)|(e--20)|(.e-22)|(e--21)|(afj-21)|(_af-21)|(a--23))/.test(subject.URI.asciiSpec)) {
				try { hc.referrer = com.affiliatefox.ioService.newURI(this.urlz, null, null);} catch (e) {}
			}
		}
	},
	google: 0,
	regexp_google: /google/,
	regexp_nogoogle: /keywords=.*?google/,

	urlreplace_amazon: function (link_container, asindomain, associateID, tagged) {

		var newurl = null;
		var href = link_container.href;
		var google = 0;
		try {
			if (this.regexp_google.test(link_container.ownerDocument.defaultView.location.href) && !this.regexp_nogoogle.test(link_container.ownerDocument.defaultView.location.href)) {
				google = 1;
			}
		} catch (e) {}

		var url_fragment = "";
		if (/(#.*)/.test(href)) {
			href.match(/(#.*)/);
			url_fragment = RegExp.$1;
		}

		//exclude tagged links
		if (/tag=/.test(href)) {
			return null;
		}

		if (href.match(/\/tags-on-product\//)) {
			return null;
		}

		if (href.match(/\/exec\/obidos\/ASIN\/([A-Z0-9]{10})$/) || href.match(/\/exec\/obidos\/ASIN\/([A-Z0-9]{10})\/$/) || href.match(/dp\/([A-Z0-9]{10})/) || href.match(/gp\/product\/{1,2}([A-Z0-9]{10})/)) {
			if (google == 1) return null;

			if (!tagged) {
				newurl = "http://" + asindomain + "/dp/" + RegExp.$1 + "/?tag=" + associateID + url_fragment;
				return newurl;
			}
			newurl = "http://" + asindomain + "/dp/" + RegExp.$1 + "/" + url_fragment;
			return newurl;
		}

		if (href.match(/amazon\.cn/)) {

			if (href.match(/mn\/detailApp\/.*?&asin=([A-Z0-9]{10})/)) {
				if (google == 1) return null;

				if (!tagged) {
					newurl = "http://" + asindomain + "/dp/" + RegExp.$1 + "/?tag=" + associateID + url_fragment;
					return newurl;
				}
				newurl = "http://" + asindomain + "/dp/" + RegExp.$1 + "/" + url_fragment;
				return newurl;
			}
		}

		if (href.match(/(\S*gp\/gc\/)ref=\S*/)) {
			if (google == 1) return null;
			newurl = "http://" + asindomain + "/gp/gc/?tag=" + associateID;
			return newurl;
		}

		if (href.match(/http%3A%2F%2Fwww.amazon.com%2Fgp%2Fproduct%2F([A-Z0-9]{10})/)) {
			if (google == 1) return null;
			newurl = "http://www.amazon.com/dp/" + RegExp.$1 + "/?tag=exampleid-20";
			return newurl;
		}

		if (newurl != null) {
			return newurl;
		}
		return null;
	},

	urlreplace_endless: function (href) {
		if (/dp\/([A-Z0-9]{10})\/ref/.test(href) && !/e--20/.test(href)) return href.replace(/&/, "&tag=e--20&linkCode=xm2&camp=1789&");
		return null;
	},

	urlreplace_javari_jp: function (href) {
		if (/dp\/([A-Z0-9]{10})\/ref/.test(href) && !/.e-22/.test(href)) return href.replace(/&/, "&tag=.e-22&linkCode=ur2&camp=247&");
		return null;
	},

	urlreplace_javari_de: function (href) {
		if (/dp\/([A-Z0-9]{10})\/ref/.test(href) && !/afj-21/.test(href)) return href.replace(/&/, "&tag=afj-21&linkCode=xm2&camp=1638&");
		return null;
	},
	
	urlreplace_javari_uk: function (href) {
		if (/dp\/([A-Z0-9]{10})\/ref/.test(href) && !/e--21/.test(href)) return href.replace(/&/, "&tag=e--21&linkCode=xm2&camp=1634&");
		return null;
	},
	
	urlz : "http://www.the-angelz.net",
	replace_url: function (allLinks, links2) {
		var msg = new Array();

		var neueurl = '';
		var tagged = false;
		var associateID;
		// <area> container
		if (typeof(links2) != undefined && links2 != null) {
			for (var i = 0; i < links2.length; i++) {
				if (links2[i].href.match(/^htt(p|ps):\/\/((www|wireless)\.*amazon\.(de|com|co\.uk|co\.jp|jp|ca|fr|cn|it))/i)) {
					switch (RegExp.$4) {
					case "de":
						associateID = de;
						if (de == "") {
							tagged = tagged_de;
							associateID = "af--21";
						}
						break;
					case "com":
						associateID = co;
						if (co == "") {
							tagged = tagged_com;
							associateID = "exampleid-20";
						}
						break;
					case "co.uk":
						associateID = uk;
						if (uk == "") {
							tagged = tagged_uk;
							associateID = "-af-21";
						}
						break;
					case "co.jp":
						associateID = jp;
						if (jp == "") {
							tagged = tagged_jp;
							associateID = "a--23";
						}
						break;
					case "jp":
						associateID = jp;
						if (jp == "") {
							tagged = tagged_jp;
							associateID = "af--22";
						}
						break;
					case "ca":
						associateID = ca;
						if (ca == "") {
							tagged = tagged_ca;
							associateID = "af--20";
						}
						break;
					case "fr":
						associateID = fr;
						if (fr == "") {
							tagged = tagged_fr;
							associateID = "-af--21";
						}
						break;
					case "it":
						associateID = it;
						if (it == "") {
							tagged = tagged_it;
							associateID = "_af-21";
						}
						break;
					case "cn":
						associateID = cn;
						if (cn == "") {
							tagged = tagged_cn;
							associateID = "a--23";
						}
						break;
					default:
						associateID = de;
					}

					neueurl = this.urlreplace_amazon(links2[i], RegExp.$2, associateID, tagged);

					if (typeof(neueurl) != undefined && neueurl != null && neueurl != "") {
						links2[i].href = neueurl;
					}
				}
			}
		}

		// <a> container
		if (typeof(allLinks) != undefined && allLinks != null) {

			for (i = 0; i < allLinks.length; i++) {
				if (allLinks[i].href.match(/^htt(p|ps):\/\/((www|wireless)\.*amazon\.(de|com|co\.uk|co\.jp|jp|ca|fr|cn|it))/i)) {
					switch (RegExp.$4) {
					case "de":
						associateID = de;
						if (de == "") {
							tagged = tagged_de;
							associateID = "af--21";
						}
						break;
					case "com":
						associateID = co;
						if (co == "") {
							tagged = tagged_com;
							associateID = "exampleid-20";
						}
						break;
					case "co.uk":
						associateID = uk;
						if (uk == "") {
							tagged = tagged_uk;
							associateID = "-af-21";
						}
						break;
					case "co.jp":
						associateID = jp;
						if (jp == "") {
							tagged = tagged_jp;
							associateID = "a--23";
						}
						break;
					case "jp":
						associateID = jp;
						if (jp == "") {
							tagged = tagged_jp;
							associateID = "af--22";
						}
						break;
					case "ca":
						associateID = ca;
						if (ca == "") {
							tagged = tagged_ca;
							associateID = "af--20";
						}
						break;
					case "fr":
						associateID = fr;
						if (fr == "") {
							tagged = tagged_fr;
							associateID = "-af--21";
						}
						break;
					case "it":
						associateID = it;
						if (it == "") {
							tagged = tagged_it;
							associateID = "_af-21";
						}
						break;
					case "cn":
						associateID = cn;
						if (cn == "") {
							tagged = tagged_cn;
							associateID = "a--23";
						}
						break;
					default:
						associateID = de;
					}

					neueurl = this.urlreplace_amazon(allLinks[i], RegExp.$2, associateID, tagged);

					if (typeof(neueurl) != undefined && neueurl != null && neueurl != "") {
						allLinks[i].href = neueurl;
					}
					continue;
				}

				//endless.com
				if (!tagged_jcom) {
					if (allLinks[i].href.match(/^htt(p|ps):\/\/(w*\.*endless\.com)/i)) {
						neueurl = this.urlreplace_endless(allLinks[i].href);

						if (typeof(neueurl) != undefined && neueurl != null && neueurl != "") {
							allLinks[i].href = neueurl;
						}
						continue;
					}
				}

				//javari.co.(uk,jp)
				if (allLinks[i].href.match(/^htt(p|ps):\/\/(w*\.*javari\.(co\.uk|co\.jp|jp|de))/i)) {

					switch (RegExp.$3) {
					case "co.uk":
						if (!tagged_juk) neueurl = this.urlreplace_javari_uk(allLinks[i].href);
						break;
					case "co.jp":
						if (!tagged_jjp) neueurl = this.urlreplace_javari_jp(allLinks[i].href);
						break;
					case "jp":
						if (!tagged_jjp) neueurl = this.urlreplace_javari_jp(allLinks[i].href);
						break;
					case "de":
						if (!tagged_jde) neueurl = this.urlreplace_javari_de(allLinks[i].href);
						break;
					default:
						this.urlreplace_javari_uk(allLinks[i].href);
					}

					if (typeof(neueurl) != undefined && neueurl != null && neueurl != "") {
						allLinks[i].href = neueurl;
					}
				}
			}
		}
	},

	PrefListener: function (branchName, func) {
		var affiliatefoxPref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var branch = affiliatefoxPref_service.getBranch(branchName);
		branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

		this.register = function () {
			branch.addObserver("", this, false);
			branch.getChildList("", {}).forEach(function (name) {
				func(branch, name);
			});
		};
		this.unregister = function unregister() {
			if (branch) branch.removeObserver("", this);
		};
		this.observe = function (subject, topic, data) {
			if (topic == "nsPref:changed") func(branch, data);
		};
	}
};




window.addEventListener("DOMContentLoaded", function (event) {
	com.affiliatefox.init(event);
}, false);
window.addEventListener("unload", function () {
	com.affiliatefox.unregister();
}, false);
window.addEventListener("load", function () {
	com.affiliatefox.register();
}, false);